#ifndef MATERIALS_H_
#define MATERIALS_H_

#include <Algebra.h>
#include <SafePointerList.h>
#include <set>
#include <map>
#include <OBJFile.h>

struct Material
{
	float shininess;
	Vector<4, VT_INSTANCE, false> ambientColour;
	Vector<4, VT_INSTANCE, false> diffuseColour;
	Vector<4, VT_INSTANCE, false> specularColour;
	float alpha;

	bool useSpecular;

	bool wireframe;

	Material()
		: shininess(0.0f)
		, ambientColour(0,0,0,0)
		, diffuseColour(0,0,0,0)
		, specularColour(0,0,0,0)
		, alpha(1.0f)
		, useSpecular(false)
		, wireframe(false)
	{};

	Material(const OBJFile::Material& mat)
	{
		shininess = mat.shininess;
		ambientColour[0] = mat.ambientColour[0];
		ambientColour[1] = mat.ambientColour[1];
		ambientColour[2] = mat.ambientColour[2];
		ambientColour[3] = 1;
		diffuseColour[0] = mat.diffuseColour[0];
		diffuseColour[1] = mat.diffuseColour[1];
		diffuseColour[2] = mat.diffuseColour[2];
		diffuseColour[3] = 1;
		specularColour[0] = mat.specularColour[0];
		specularColour[1] = mat.specularColour[1];
		specularColour[2] = mat.specularColour[2];
		specularColour[3] = 1;
		alpha = mat.alpha;
		useSpecular = mat.useSpecular;
	}
};

#endif
