#ifndef RESOURCECREATORWORKER_H_
#define RESOURCECREATORWORKER_H_

#include "ResourceCreator.h"
#include <ThreadPrimitives.h>

class ResourceCreatorWorker
{
	ResourceCreator& m_creator;

	Thread* m_thread;

	ThreadSafeAllocator& m_allocator;

	int m_workerId;

	void Run();

	void ProcessWorkOrder(ResourceCreator::WorkOrder* workOrder);

public:
	ResourceCreatorWorker(ResourceCreator& creator, int workerId, ThreadSafeAllocator& allocator);
	~ResourceCreatorWorker();

	Thread::ID GetThreadID() const {return m_thread->GetID();}
};

#endif
