#include "ArcBall.h"

UnitQuaternion GetRotationFromArcBallPointDelta(const Vector<2>& from, const Vector<2>& to)
{
	Vector<2> processedFrom(from);
	Vector<2> processedTo(to);

	if(processedFrom.LengthSquared() > 1.0f)
	{
		processedFrom.Normalize();
		processedFrom *= 0.99999f;
	}
	if(processedTo.LengthSquared() > 1.0f)
	{
		processedTo.Normalize();
		processedTo *= 0.99999f;
	}
	
	float diffx = processedFrom[0] - processedTo[0];
	float diffy = processedFrom[1] - processedTo[1];
	if(diffx*diffx + diffy*diffy < 0.000001f)
	{
		return UnitQuaternion();
	}

	// Determine the 3d points from the 2d points
	Vector<3> from3(processedFrom[0], processedFrom[1], sqrt(1 - processedFrom.LengthSquared()));
	Vector<3> to3(processedTo[0], processedTo[1], sqrt(1 - processedTo.LengthSquared()));

	Vector<3> crossed = Cross(from3, to3);
	float dot = Dot(from3, to3);

	if(dot == 1.0f) dot = -0.9999f;

	float factor = sqrt(2*(1 + dot));
	Vector<3> v = crossed / factor;

	Vector<4> useVec(v[0], v[1], v[2], factor/2);

	return UnitQuaternion((abs(1.0f - useVec.LengthSquared()) < 0.000001f ? useVec : useVec.Normalized()));
}

