#include "TriangleMesh.h"

TriangleMesh::TriangleMesh()
{
}


int TriangleMesh::AddVertex(const Vertex& pos)
{
	m_vertices.push_back(pos);
	return m_vertices.size()-1;
}

void TriangleMesh::AddTriangle(const Triangle& tri)
{
	m_triangles.push_back(tri);
}



void TriangleMesh::FillInNormals()
{
	for(TriangleArray::iterator iter = m_triangles.begin(); iter != m_triangles.end(); ++iter)
	{
		Triangle& curTri = *iter;

		if(curTri.HasNormals()) continue;

		const Vertex& vert1 = m_vertices[curTri.GetVertex(0)];
		const Vertex& vert2 = m_vertices[curTri.GetVertex(1)];
		const Vertex& vert3 = m_vertices[curTri.GetVertex(2)];

		Vector<3> vec1 = vert2 - vert1;
		Vector<3> vec2 = vert3 - vert1;

		Vector<3> normal = Cross(vec1, vec2).Normalized();

		// Assign the normal to all vertices of the triangle
		curTri.SetNormals(normal, normal, normal);
	}
}
