#include "Utils.h"

#include <iostream>

#ifdef COMPILER_MSVC
#include <assert.h>
#else
class AssertionException {};
#endif

void top_assert(bool cond, const char* condStr, const char* file, int line, const char* msg)
{
	if(!cond)
	{
		std::cerr << std::endl << "ASSERTION FAILURE -- (" << condStr << ") @ " << file << ":" << line << std::endl;
		std::cerr << msg << std::endl;

#ifdef COMPILER_MSVC
		assert(false);
#else
		throw AssertionException();
#endif
	}
}
