#include <BoundedQueue.h>

#include <iostream>
#include <boost/bind.hpp>

static void Writer(BoundedQueue<int>* msgQueue)
{
	for(int i=0; i<50; ++i)
	{
		std::cout << "Pushing " << i << std::endl;
		msgQueue->Push(i);
	}
}
static void Reader(BoundedQueue<int>* msgQueue)
{
	for(int i=0; i<50; ++i)
	{
		std::cout << "Popping " << msgQueue->Pop() << std::endl;
	}
}

int main(int argc, char** args)
{
	BoundedQueue<int> m_testQueue(10);

	{
		Thread writer1(boost::bind(&Writer, &m_testQueue));
		Thread writer2(boost::bind(&Writer, &m_testQueue));
		Thread reader1(boost::bind(&Reader, &m_testQueue));
		Thread reader2(boost::bind(&Reader, &m_testQueue));
	}
	
	ASSERT(m_testQueue.GetSize() == 0);
	std::cout << "Passed test 1" << std::endl;

	{
		Thread reader1(boost::bind(&Reader, &m_testQueue));
		Thread reader2(boost::bind(&Reader, &m_testQueue));
		Thread writer1(boost::bind(&Writer, &m_testQueue));
		Thread writer2(boost::bind(&Writer, &m_testQueue));
	}
	
	ASSERT(m_testQueue.GetSize() == 0);
	std::cout << "Passed test 2" << std::endl;

	{
		Thread writer1(boost::bind(&Writer, &m_testQueue));
		Thread reader1(boost::bind(&Reader, &m_testQueue));
		Thread reader2(boost::bind(&Reader, &m_testQueue));
		Thread writer2(boost::bind(&Writer, &m_testQueue));
	}
	
	ASSERT(m_testQueue.GetSize() == 0);
	std::cout << "Passed test 3" << std::endl;

	return 0;
}
