#ifndef CAMERA_H_
#define CAMERA_H_

#include <Algebra.h>
#include <R3Utils.h>

class Camera
{
	Matrix<4,4> m_camRotation;
	Vector<4> m_camPos;

	public:
	Camera()
	: m_camRotation(MakeIdentityMatrix())
	, m_camPos(0,0,0,1)
	{};

	Camera(const Matrix<4,4>& camMat);
	
	~Camera()
	{};

	void SetPosition(const Vector<4>& pos)
	{
		m_camPos = -pos;
	}
	const Vector<4> GetPosition() const
	{
		return -m_camPos;
	}
	void AddPitch(float angle);
	void AddYaw(float angle);

	const Matrix<4,4>& GetRotMatrix() {return m_camRotation;}

	Matrix<4,4> GetTransMatrix() const;
	Matrix<4,4> GetModelView() const;
};

#endif
